% UC: 21180 - Computação Numérica
% e-fólio B 2024-25
%
% Aluno: 1100477 - Sergio Rosa
%
% -------------------------------------------------------------
% Script: efb.m
%
% Descrição:
%   Demonstra o funcionamento da função sol_lu_mat().
%   1) Cria uma matriz A (8x8) e X_0 (8x8) com valores aleatórios.
%   2) Define B = A * X_0.
%   3) Chama X = sol_lu_mat(A, B, tol).
%   4) Calcula e imprime o erro usando a norma infinita.
%
% -------------------------------------------------------------

% Inicialização de variáveis
matriz_size=8; % Tamanho da matriz
tol=1e-6; % Tolerância para detetar singularidade

% Formatação de output
format bank;

% 1) Cria a matriz A (8x8) e X_0 (8x8) com valores em [-5, 5],
%    arredondados a 2 casas decimais
A = (round(rand(matriz_size)*1000))/100-5; % Matriz A 
X_0 = (round(rand(matriz_size)*1000))/100-5; % Matriz X_0

% 2) Calcula B = A * X_0
if size(A,2) ~= size(X_0,1)
    error('As dimensões de A e X0 não são compatíveis')
    X=[];
    return;
else
    % Calcula B com base na Matriz A e X_0
    B = A * X_0;

    % 3) Chama a função de resolução com determinada tolerância
    X = sol_lu_mat(A, B, tol);

    % Output dados
    fprintf('Matriz A:\n');
    disp(A);
    fprintf('Matriz X_0 (Real):\n');
    disp(X_0);
    fprintf('Matriz B:\n');
    disp (B);
end

% Se retornou vazio, significa que A foi considerada singular
if isempty(X)
  fprintf('Matriz A foi considerada singular ou proxima de singularidade.\n');
  return;
else
  fprintf('Matriz X (Calculada):\n');
  disp(X);
  % 4) Calcula e imprime o erro entre X0 e X com a norma infinita
  %    erro = norma_inf_mat(X0 - X)
  erro = norma_inf_mat(X - X_0);
  fprintf('Norma infinita do Erro: %.2e\n', erro); % Apresentação em valor cientifico devido aos valores reduzidos
end