% UC: 21180 - Computação Numérica
% e-fólio B 2024-25
%
% Aluno: 1100477 - Sergio Rosa
%
% -------------------------------------------------------------
% Função: norma_inf_mat(A)
%
% Descrição:
%   Calcula a norma infinita de uma matriz A.
%
% Parâmetro de entrada:
%   A - Matriz de dimensão (nxm)
%
% Parâmetro de saída:
%   N - Norma infinita da matriz A
%
% -------------------------------------------------------------
function N = norma_inf_mat(A)

    % Número de linhas
    [m, ~] = size(A);

    % Inicializa o valor da norma
    N = 0;
    % Percorre cada linha
    for i = 1:m
        % Soma dos valores absolutos dos elementos da linha i
        rowSum = sum(abs(A(i, :)));

        % Atualiza o máximo
        if (rowSum > N)
            N = rowSum;
        end
    end
end

